#!/usr/bin/python
import os
import time
import json
import re
from e3dc import E3DC
import socket  
import paho.mqtt.client as mqtt
import sys

import subprocess

dir_main = '/opt/'
dir_main2 = 'loxberry/'
dir_conf = 'config/plugins/e3dc/'
dir_bin = 'bin/plugins/e3dc/'
dir_log = 'log/plugins/e3dc/'

process = subprocess.Popen(". " + dir_main + dir_main2 + dir_bin + "pre_log.sh", shell=True, stdout=subprocess.PIPE)
process.wait()
process = subprocess.Popen(". " + dir_main + dir_main2 + dir_bin + "data_min.sh", shell=True, stdout=subprocess.PIPE)

s = os.popen(". " + dir_main + dir_main2 + dir_conf + "e3dc.cfg && set").read()
env_vars = {x[:x.find("=")]:x[x.find("=")+2:-1] for x in s.split("\n")[:-1]}

TCP_IP = env_vars['E3DC_IP']
USERNAME = env_vars['E3DC_USER']
PASS = env_vars['E3DC_PASS']
KEY = env_vars['E3DC_KEY']
DEBUG = (int(env_vars['E3DC_DEBUG']))
DCDC= (int(env_vars['E3DC_DCDC']))
mqtt_username = env_vars['MQTT_USER']
mqtt_password = env_vars['MQTT_PASS']
host = env_vars['MQTT_HOST']
port = (int(env_vars['MQTT_PORT']))
count = 0
def on_disconnect(client, userdata, rc):
    if rc != 0:
        print("Unexpected MQTT disconnection. Will auto-reconnect")
        mqttc.connect(host, port, 60)
        print("Reconnecting to "+host+" port: "+str(port))

def on_connect(mqttc, obj, flags, rc):
    print("connect rc: " + str(rc))

topic = 'e3dc/current'
mqttc = mqtt.Client()
mqttc.username_pw_set(mqtt_username, mqtt_password)
mqttc.on_connect = on_connect
mqttc.connect(host, port, 60)

e3dc = E3DC(E3DC.CONNECT_LOCAL, username=USERNAME, password=PASS, ipAddress = TCP_IP, key = KEY)
#print (DCDC)
while True:    
    if DCDC == 1:
        res=(e3dc.poll_rscp_dc())
    else:
        res=(e3dc.poll_rscp())
    
    result = str(res)
    result = re.sub("(.*\:).*", "\\1", result)
    size = len(result)
    result = result[:size - 9]
    result = result + ('}')
    result = result.replace('\'', '\"')
    result_mqtt = result
    mqttc.on_disconnect = on_disconnect
    infot = mqttc.publish(topic, result_mqtt , qos=0)
    #print(result_mqtt)
    time.sleep(1.2)
    count += 1
    if count == 48:
        process = subprocess.Popen(". " + dir_main + dir_main2 + dir_bin + "data_min.sh", shell=True, stdout=subprocess.PIPE)
        count = 0

mqttc.disconnect()
sys.stderr = open(dir_main + dir_main2 + dir_log + 'e3dc_error.log', 'w')
