#!/usr/bin/python
import sys
import getopt
import os
import time
import json
import re
from e3dc import E3DC
import socket  
import datetime 

dir_1 = '/opt/'
dir_2 = 'loxberry/'
dir_3 = 'config/plugins/e3dc/'

s = os.popen(". " + dir_1 + dir_2 + dir_3 + "e3dc.cfg && set").read()
env_vars = {x[:x.find("=")]:x[x.find("=")+2:-1] for x in s.split("\n")[:-1]}

TCP_IP = env_vars['E3DC_IP']
USERNAME = env_vars['E3DC_USER']
PASS = env_vars['E3DC_PASS']
KEY = env_vars['E3DC_KEY']
#DEBUG = env_vars['E3DC_DEBUG']
UDP_IP_ADDRESS = env_vars['MINISERVER_IP'] 
UDP_PORT_NO = (int(env_vars['MINISERVER_UDP_PORT']))

if len(sys.argv) < 5:
   print("Not all arguments are given! eg. DAY 2020 1 1")
   exit()

param_1= sys.argv[1] 
param_2= (int(sys.argv[2]))
param_3= (int(sys.argv[3]))
param_4= (int(sys.argv[4]))

e3dc = E3DC(E3DC.CONNECT_LOCAL, username=USERNAME, password=PASS, ipAddress = TCP_IP, key = KEY)
res=(e3dc.get_db_data(startDate=datetime.date(param_2, param_3, param_4), timespan=param_1,  keepAlive=False )) 
result = json.dumps(res)
result = json.loads(result)
udp_str="e3dc.db.bat_power_in=%s e3dc.db.bat_power_out=%.2f e3dc.db.solarProduction=%.2f e3dc.db.grid_power_in=%.2f e3dc.db.grid_power_out=%.2f e3dc.db.consumption=%.2f e3dc.db.stateOfCharge=%.2f e3dc.db.consumed_production=%.2f e3dc.db.autarky=%.2f" % ((result['bat_power_in'] / 1000), (result['bat_power_out'] / 1000), (result['solarProduction'] / 1000), (result['grid_power_in'] / 1000), (result['grid_power_out'] / 1000), (result['consumption'] / 1000), result['stateOfCharge'], result['consumed_production'], result['autarky'])
clientSock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
clientSock.sendto(udp_str.encode(), (UDP_IP_ADDRESS, UDP_PORT_NO))


   




