<?php
require_once "loxberry_system.php";
include 'e3dc_functions.php';
error_reporting(0);

//CONFIG
$file_config = $lbpconfigdir . '/e3dc.cfg';

//---------------------------------------------------------------------------------------------------
$do         = ($_GET["do"]);
$v1         = ($_GET["v1"]);
$v2         = ($_GET["v2"]);
$v3         = ($_GET["v3"]);
$v4         = ($_GET["v4"]);
$file_log_i = $lbplogdir . '/e3dc.log';
//---------------------------------------------------------------------------------------------------
//READ CONFIG-FILE
$config     = parse_ini_file($file_config, TRUE);
//print_r ($config); 

$do_arr = array(
    "getIdlePeriods",
    "getPower",
    "getPowerSettings",
    "getPowerData",
	"getEPSettings",
    "getBatteryData",
	"getBatteriesData",
    "getSystemInfo",
    "getSystemInfoStatic",
    "getPviData",
    "getPowerDataExt",
	"getDCDC",
    "getEPR",
	"setEPR",
	"setGridLoad", 
    "setWeatherRegulatedCharge",
    "setPowerLimits",
    "setIdleTime",
	"setIdleTime",
	"setIdleTimeFull",
	"db_today",
    "db_yesterday",
    "db_month",
    "db_month_last",
    "db_year",
    "db_year_last"
);

if (!in_array("$do", $do_arr)) {
    echo "do is missing or wrong!! <br>";
    exit();
}

switch ($do) {
    case "getIdlePeriods":
        $output                    = shell_exec("python3 $lbpbindir/control.py -d getIdlePeriods");
        $json                      = json_decode($output, true);
        $day                       = (date('N') - 1);
        $minutes                   = ltrim(date('i'), '0');
        $hours                     = date('G');
        $date_now                  = date("d.m.Y");
        $timestamp_now             = strtotime($date_now . ' ' . $hours . ':' . $minutes);
        $timestamp_charge_start    = strtotime($date_now . ' ' . $json['idleCharge'][$day]['start']['0'] . ':' . $json['idleCharge'][$day]['start']['1']);
        $timestamp_charge_stop     = strtotime($date_now . ' ' . $json['idleCharge'][$day]['end']['0'] . ':' . $json['idleCharge'][$day]['end']['1']);
        $timestamp_discharge_start = strtotime($date_now . ' ' . $json['idleDischarge'][$day]['start']['0'] . ':' . $json['idleDischarge'][$day]['start']['1']);
        $timestamp_discharge_stop  = strtotime($date_now . ' ' . $json['idleDischarge'][$day]['end']['0'] . ':' . $json['idleDischarge'][$day]['end']['1']);
        if (($json['idleCharge'][$day]['active'] == 1) && ($timestamp_now > $timestamp_charge_start && $timestamp_now < $timestamp_charge_stop)) {
            $idlecharge = 1;
        } else {
            $idlecharge = 0;
        }
        if (($json['idleDischarge'][$day]['active'] == 1) && ($timestamp_now > $timestamp_discharge_start && $timestamp_now < $timestamp_discharge_stop)) {
            $idledischarge = 1;
        } else {
            $idledischarge = 0;
        }
		$output = '{"idelCharge": '.$idlecharge.', "idelDischarge": '.$idledischarge.'}';
	    $id = 'idleperiods';
		$output_mqtt = array();
		$output_mqtt['idelCharge'] = $idlecharge;
		$output_mqtt['idelDischarge'] = $idledischarge;
		send_mqtt($id, $output_mqtt);
		break;
    case "getPower":
        $output = shell_exec("python3 $lbpbindir/control.py -d getPower");       
		break;
    case "getEPSettings":
        $output = shell_exec("python3 $lbpbindir/control.py -d getEPSettings");      
		break;
    case "getPowerSettings":
        $output = shell_exec("python3 $lbpbindir/control.py -d getPowerSettings");       
		break;
    case "getPowerData":
        $output = shell_exec("python3 $lbpbindir/control.py -d getPowerData");     
		break;
    case "getBatteryData":
        $output = shell_exec("python3 $lbpbindir/control.py -d getBatteryData");      
		break;
    case "getBatteriesData":
        $output = shell_exec("python3 $lbpbindir/control.py -d getBatteriesData");        
		break;
	case "getSystemInfo":
        $output = shell_exec("python3 $lbpbindir/control.py -d getSystemInfo");        
		break;
    case "getPviData":
        $output = shell_exec("python3 $lbpbindir/control.py -d getPviData");      
		break;
    case "getPowerDataExt":
        $output = shell_exec("python3 $lbpbindir/control.py -d getPowerDataExt");      
		break;
    case "getDCDC":
        $output = shell_exec("python3 $lbpbindir/control.py -d getDCDC");       
		break;
    case "getEPR":
        $output = shell_exec("python3 $lbpbindir/control.py -d getEPR");
echo $output;		
		break;		
    case "setPowersave":
        if ($v1 == null) {
            echo "Value V1 is missing!";
            exit();
        }
        $output = shell_exec("python3 $lbpbindir/control.py -d setPowersave -v1 " . $v1);      
		break;    
    case "setWeatherRegulatedCharge":
        if ($v1 == null) {
            echo "Value V1 is missing!";
            exit();
        }
        $output = shell_exec("python3 $lbpbindir/control.py -d setWeatherRegulatedCharge -v1 " . $v1);       
		break;
    case "setPowerLimits":
        if ($v1 == 0) {
            $output=shell_exec("python3 $lbpbindir/control.py -d getPowerSettings");
            $json   = json_decode($output, true);
            $v2     = $json['maxChargePower'];
            $v3     = $json['maxDischargePower'];
            $v4     = $json['dischargeStartPower'];
        } elseif ($v1 == 1) {
            shell_exec("python3 $lbpbindir/control.py -d getPowerSettings");
            $json   = json_decode($output, true);
            if ($v2 == null) {
                $v2 = $json['maxChargePower'];
            }
            if ($v3 == null) {
                $v3 = $json['maxDischargePower'];
            }
            if ($v4 == null) {
                $v4 = $json['dischargeStartPower'];
            }
        }
		$output = shell_exec("python3 $lbpbindir/control.py -d setPowerLimits -v1 " . $v1 . " -v2 " . $v2 . " -v3 " . $v3 . " -v4 " . $v4);
		
		break;
	case "setEPR":
		if ($v1 == null) {
            echo "Value V1 is missing!";
            exit();
        }
		$output = shell_exec("python3 $lbpbindir/control.py -d setEPR -v1 " . $v1);		
		break;
	case "setIdleTime":
		if ($v1 == null or $v2 == null) {
            echo "Value V1/V2 is missing!";
            exit();
        }
		$output = shell_exec("python3 $lbpbindir/control.py -d setIdleTime -v1 " . $v1 . " -v2 " . $v2);		
		break;
	case "setIdleTimeFull":
		if ($v1 == null or $v2 == null) {
            echo "Value V1/V2 is missing!";
            exit();
        }
		$output = shell_exec("python3 $lbpbindir/control.py -d setIdleTimeFull -v1 " . $v1 . " -v2 " . $v2);		
		break;
    case "db_today":
        $output = shell_exec("python3 $lbpbindir/db.py DAY NOW");    
		break;
    case "db_yesterday":
        $output = shell_exec("python3 $lbpbindir/db.py DAY LAST");
		break;
    case "db_month":
        $output = shell_exec("python3 $lbpbindir/db.py MONTH NOW");     
		break;
    case "db_month_last":
        $output = shell_exec("python3 $lbpbindir/db.py MONTH LAST");
        break;
    case "db_year":
        $output = shell_exec("python3 $lbpbindir/db.py YEAR NOW");
        break;
    case "db_year_last":
        $output = shell_exec("python3 $lbpbindir/db.py YEAR LAST");
        break;  	
   case "setGridLoad":
		if ($v1 == null or $v2 == null) {
            echo "Value V1/V2 is missing!";
            exit();
        }
		$bat_data = shell_exec("python3 $lbpbindir/control.py -d getBatteryData");
		$bat_data=(json_decode($bat_data, TRUE));
		$cap=$bat_data['usuableCapacity']*51.201;
		if ($v1 == 1) {
			$load_ERP=round($cap*(round($v2,0)/100),0);	
			shell_exec("python3 $lbpbindir/control.py -d setIdleTimeFull -v1 1 -v2 1");
			sleep(0.5);
			shell_exec("python3 $lbpbindir/control.py -d setEPR -v1 ".$load_ERP);
		}
		if ($v1 == 0) {
			shell_exec("python3 $lbpbindir/control.py -d setIdleTimeFull -v1 1 -v2 0");
			sleep(0.5);
			if ($v2 != null){
				$reset_ERP=round($cap*(round($v2,0)/100),0);	
				shell_exec("python3 $lbpbindir/control.py -d setEPR -v1 ".$reset_ERP);
			} else {
				shell_exec("python3 $lbpbindir/control.py -d setEPR -v1 0");
			}
		}
		if ($v1 == 2) {
			if ($v2 != null){
				$reset_ERP=round($cap*(round($v2,0)/100),0);	
				shell_exec("python3 $lbpbindir/control.py -d setEPR -v1 ".$reset_ERP);
			} else {
				shell_exec("python3 $lbpbindir/control.py -d setEPR -v1 0");
			}
		}
		break;		
}
echo $output;