<?php
//PREPARE ARRAY FOR MQTT
function prefixKey($prefix, $array)
{
    $result = array();
    foreach ($array as $key => $value) {
        if (is_array($value))
            $result = array_merge($result, prefixKey($prefix . $key . '.', $value));
        else
            $result[$prefix . $key] = $value;
    }
    return $result;
}
//SEND MQTT
function send_mqtt($id, $message)
{
    require_once "loxberry_io.php";
    require_once "phpMQTT.php";
    $creds     = mqtt_connectiondetails();
    $client_id = uniqid(gethostname() . "_client");
    $mqtt      = new Bluerhinos\phpMQTT($creds['brokerhost'], $creds['brokerport'], $client_id);
    if ($mqtt->connect(true, NULL, $creds['brokeruser'], $creds['brokerpass'])) {
        $message = prefixKey('', $message);
        foreach ($message as $x => $val) {
            echo 'e3dc/' . $id . '/' . $x . '=' . $val . '<br>';
            $mqtt->publish("e3dc/" . $id . "/" . $x, $val, 0 ,0);
        }
        $mqtt->close();
    } else {
        echo "MQTT connection failed";
    }
}
//LOG
	function log_i ($text, $file_log) {
		$time_e=date("Y-m-d  H:i:s");
		$message_j = json_encode($text);
		$message_s =$time_e.' - ';
		$message_s .=$message_j;
		$myfile = file_put_contents($file_log, $message_s.PHP_EOL , FILE_APPEND | LOCK_EX);
	}